/****************************************************************************
**
** Copyright (C) 2004-2005 Trolltech AS. All rights reserved.
**
** This file is part of the example classes of the Qt Toolkit.
**
** This file may be used under the terms of the GNU General Public
** License version 2.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of
** this file.  Please review the following information to ensure GNU
** General Public Licensing requirements will be met:
** http://www.trolltech.com/products/qt/opensource.html
**
** If you are unsure which license is appropriate for your use, please
** review the following information:
** http://www.trolltech.com/products/qt/licensing.html or contact the
** sales department at sales@trolltech.com.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#ifndef FTPWINDOW_H
#define FTPWINDOW_H

#include "mainform.h"
#include <QDialog>
#include <QHash>
#include "ui_ftpwindow.h"
#include "base.h"

class QFile;
class QFtp;
class QLabel;
class QLineEdit;
class QListWidget;
class QListWidgetItem;
class QProgressDialog;
class QPushButton;
class QUrlInfo;

class FtpWindow : public QDialog, public Ui::FtpWindow
{
    Q_OBJECT

public:
    FtpWindow(MainForm *parent = 0);
    inline bool done() {return ok;};
    inline FileFormat getFormat() {return format;};
    inline QString getFname() {return mainfilename;};
     bool  listContains(QString );
private slots:
    void connectOrDisconnect();
    void downloadFile(QString);
    void downloadFiles();
    void cancelDownload();

    void ftpCommandFinished(int commandId, bool error);
    void addToList(const QUrlInfo &urlInfo);
    void processItem(QListWidgetItem *item);
    void cdToParent();
    void updateDataTransferProgress(qint64 readBytes,
                                    qint64 totalBytes);
    void enableDownloadButton();

private:
//    QLabel *ftpServerLabel;
//    QLineEdit *ftpServerLineEdit;
//    QLabel *statusLabel;
//    QListWidget *fileList;
//    QPushButton *quitButton;
//    QPushButton *connectButton;
//    QPushButton *downloadButton;
//    QPushButton *cdToParentButton;
    MainForm* p;
    DataStore* data;
    QProgressDialog *progressDialog;
    QHash<QString, bool> isDirectory;
    QString currentPath;
    QFtp *ftp;
    QFile *file;
    bool ok;
    FileFormat format;
    QString tempdir;
    QString mainfilename;
    QStringList allFiles;
    void addToAllFiles(QString);
};

#endif
